package blusci;

import processing.core.*; 
import fullscreen.*;  //um im Vollbildmodus starten zu können.

import org.scilab.modules.javasci.Scilab;
import org.scilab.modules.types.ScilabType;
import org.scilab.modules.types.ScilabDouble;

import kiba.hilfsklassen.Dateioperationen;

public class BLUSCI extends PApplet
{
    int zaehler = 0;
    Scilab sci;
    
    int zustand = 0;
    
    Dateioperationen dateioperationen;
    
    double[][] ysim;
    
    public void setup()
    {
        dateioperationen = new Dateioperationen();

        String skript = dateioperationen.ladeText("schwinger.sci");
        String[] skriptzeilen = dateioperationen.ladeZeilen("schwinger.sci");
        System.out.println("Skript:\n"+skript);
        try
        {
            sci = new Scilab();
            sci.open(); 
            
            
            //Skript in eine Zeile packen:
            StringBuffer sb = new StringBuffer();
            for(int i=0;i<skriptzeilen.length;i++)
                sb.append(skriptzeilen[i]);
            
            
            //sci.exec(skript);
            for(int i=0;i<skriptzeilen.length;i++)
                sci.exec(skriptzeilen[i]);
            //sci.exec("y=[1,2,3];");
            //sci.exec(sb.toString());
            ScilabType y = sci.get("y");
            //System.out.println("Representation of y:\n"+y);
            
            //Umwandeln in ein double-Array:
            ysim = ((ScilabDouble)y).getRealPart();
            
        }
        catch(Exception e)
        {
            System.out.println("Problem beim Öffnen von Scilab:"+e);
            System.exit(0);
        }
        size(displayWidth, displayHeight);
        frameRate(20);
        (new FullScreen(this)).enter();         
    }
    
    public void draw()
    {
        clear();
        fill(0);
        rect(0,0,displayWidth,displayHeight);

        fill(255,0,0);
        ellipse(50.0f+(float)(400.0*(ysim[0][zaehler]+1.0)),60,50,50);

        
        zaehler+=5;
        zaehler%=ysim[0].length;
    }   

    public void mouseClicked()
    {
        if(zustand==0)
        {
            zustand++;
            sci.exec("foo = [ 2, 4, 6; 4, 0, 10; 6, 10, 12 ];");

            try
            {
                ScilabType foo = sci.get("foo");
                System.out.println("Representation of  : "+foo);
            }
            catch(Exception e)
            {
                System.out.println("Problem bei der Ausführung eines Scilab-Befehls:"+e);
            }
            
        }
        else
        {
            sci.close();
            System.exit(0);
        }
    }
    
    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "blusci.BLUSCI" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }    
}
