package blusci;

import java.util.*;

import processing.core.*; 
import fullscreen.*;  //um im Vollbildmodus starten zu können.

import codeanticode.gsvideo.*;
import processing.serial.*;

import org.scilab.modules.javasci.Scilab;
import org.scilab.modules.types.ScilabType;
import org.scilab.modules.types.ScilabDouble;

import kiba.hilfsklassen.Dateioperationen;

import kiba.betriebssystem.Linuxsystem;

public class BLUSCI7SPRUNG extends PApplet
{
    //MERKER FÜR SPRUNGANTWORT:
    int SPRUNG = 0;
    long ZEIT;
    ArrayList<long[]> merker;
    
    float IANTEIL = 0.0f;
    
    boolean ROTATE = false;
    
    Scilab sci;
    
    int zaehler = 0; //für die Animation des roten Balls
    
    Dateioperationen dateioperationen;
    Linuxsystem linuxsystem;
    GSCapture webcam;
    PImage    bild;
    
    Serial myPort;  // Create object from Serial class    
    
    public void sprich(String text)
    {
        if(linuxsystem!=null)
            linuxsystem.syst("espeak -s100 -k20 -v mb-de7 \""+text+"\"");
        System.out.println(text);            
    }
    
    public void setup()
    {
        dateioperationen = new Dateioperationen();
        linuxsystem      = new Linuxsystem();
        try
        {
            sci = new Scilab();
            sci.open();                                     
        }
        catch(Exception e)
        {
            sprich("Problem beim Öffnen von Scilab:"+e);
            System.exit(0);
        }

        try
        {
//          webcam = new GSCapture(this,640,480,"/dev/video0");
          webcam = new GSCapture(this,640,480);
          webcam.start();
          bild = new PImage(640,480);
        }
        catch(Exception ee)
        {
            sprich("Problem beim Start der Kamera:"+ee);
            System.exit(0);
        }

        
        //Serielle Verbindung vorbereiten:
        linuxsystem.syst("ln -s  /dev/ttyACM0 /dev/ttyS80"); //wird nur gemacht, wenn noch nicht da.
        linuxsystem.syst("rm -f /var/lock/LCK..ttyS80");
        
        try
        {
            myPort = new Serial(this,"/dev/ttyS80", 9600);                
        }
        catch(Exception eee)
        {
            sprich("Problem beim Einrichten der seriellen Verbindung:"+eee);
            System.exit(0);
        }
        
//        sprich("Animation des grünen Balls, die Kamera und der Motorregler werden gestartet.");
        size(displayWidth, displayHeight);
        frameRate(30);
        (new FullScreen(this)).enter();         
    }

    public void mouseClicked()
    {
        ROTATE = !ROTATE;
    }
    
    public void draw()
    {           
        int PWM=0;
        
        clear();
        fill(0);
        rect(0,0,displayWidth,displayHeight);
        fill(0,255,0);
        noStroke();
        
//SPRUNGANTWORT: Grünen Ball auf die Mitte setzen!        
        zaehler = displayWidth/8;
        
        if(zaehler<displayWidth/4)
            ellipse(displayWidth/4 + displayWidth/8 + zaehler,200,40,40);
        else
            ellipse(displayWidth/4 + displayWidth/8  + displayWidth/2 - zaehler,200,40,40);

            
        if(webcam!=null && webcam.available())
        {
            webcam.read();
            webcam.loadPixels();
            for(int i=0;i<webcam.pixels.length;i++)
                 bild.pixels[webcam.pixels.length-1-i]=webcam.pixels[i];
            bild.updatePixels();            
            set(displayWidth/2-640/2,displayHeight/2,bild);
            
            //Aktuelle Regelabweichung bestimmen:
            //1. Schwerpunkt der roten Pixel in der oberen Bildhälfte von Bild bestimmen:
            float xg = 0.0f; //gewichtete Position aufsummiert
            float x = 0.0f;  //horizontale Schwerpunktkoordinate
            float g = 0.0f;  //Gewichte aufsummiert
            bild.loadPixels();
            for(int i=0;i<bild.pixels.length/2;i++)
            {
                 float rot   = red(bild.get(i%640,i/640));
                 float gruen = green(bild.get(i%640,i/640));
                 float blau  = blue(bild.get(i%640,i/640));
                 float ROT   = (rot-(gruen+blau)*0.5f);
                 float BLAU   = (blau-(rot+gruen)*0.5f);
                 float GRUEN   = (gruen-(rot+blau)*0.5f);
                 if(GRUEN<0.0f)
                     GRUEN=0.0f;
                 g+=GRUEN;
                 xg+=GRUEN*(float)(i%640);                 
            }
            if(g>0.0f)
                x = xg/g;
            else
                x = 320.0f;
            //Schwerpunkt als senkrechte gelbe Linie im Bild einzeichnen:
            stroke(255,255,0);
            line(x+displayWidth/2-640/2,displayHeight/2,x+displayWidth/2-640/2,displayHeight/2+480);

            //Mitte weiss einzeichnen:
            line(320+displayWidth/2-640/2,displayHeight/2,320+displayWidth/2-640/2,displayHeight/2+480);
            
            //Einfachen Proportionalregler implementieren:            
            if ( myPort!=null && myPort.available() >= 1) 
            {
                float EREG = (320.0f - x);  //Regeldifferenz

                IANTEIL+=EREG;

                float FPWM = (0.005f*EREG) + 0.001f*IANTEIL;
                
                if(FPWM>0.0f)
                {
                    FPWM+=1.0f;
                    PWM = (int)(FPWM+0.5f);
                }                    
                else if(FPWM<0.0f)
                {
                    FPWM-=1.0f;
                    PWM = (int)(FPWM-0.5f);
                }
                    
                if(PWM>20)
                    PWM=20;
                if(PWM<-20)
                    PWM=-20;
                    
                PWM = -PWM;    

//SPRUNGANTWORT: PWM immer auf 4, ausser, wenn die Taste gedrückt wird:                
                PWM=2;                

                if(ROTATE)
                {
                    /*
                    if(SPRUNG==-1)
                    {
                        if((long)(x - 320.0f)!=0)
                        {
                            PWM=3;                
                            SPRUNG=-1;
                        }
                        else
                        {
                            SPRUNG=0;
                            PWM=0;                
                        }
                    }
                    */
                    if(SPRUNG==0)
                    {
                        PWM=0;
                        merker = new ArrayList<long[]>();
                        SPRUNG++;
                    }
                    else if(SPRUNG>0 && SPRUNG<10)
                    {
                        PWM=0;
                        SPRUNG++;
                    }
                    else if(SPRUNG==10)
                    {
                        PWM=-4;
                        ZEIT=System.currentTimeMillis();
                        //Aktuellen Pixelwert und Zeitpunkt merken:
                        merker.add(new long[] {(long)(0),(long)(x - 320.0f)});
                        SPRUNG++;
                    }
                    else if(SPRUNG>10 && SPRUNG<20)
                    {
                        PWM=-4;
                        //Aktuellen Pixelwert und Zeitpunkt merken:
                        merker.add(new long[] {(long)(System.currentTimeMillis()-ZEIT),(long)(x - 320.0f)});
                        SPRUNG++;
                    }
                    else //SPRUNG==50
                    {
                        PWM=0;
                        ROTATE=false;
                        //speichern:
                        StringBuffer sb = new StringBuffer();
                        sb.append("arr=[");
                        for(int rr=0;rr<merker.size();rr++)
                        {
                            long[] zx = merker.get(rr);
                            sb.append(zx[0]+", "+zx[1]);
                            if(rr<merker.size()-1)
                                sb.append("; \n");
                            else                                
                                sb.append("]; \n");
                        }
                        dateioperationen.speichern("arrsprung.txt",sb.toString());
                        SPRUNG++;
                    }
                    
                    
                    IANTEIL=0.0f; //I-Anteil zurücksetzen                    
                }  
                else
                {
                    SPRUNG=0;
                }
                myPort.write(PWM+20);
           
                
                
                text("PWM="+PWM,20,400);
                text("REGELABWEICHUNG="+(320.0f-x),20,430);
                text("SPRUNG="+SPRUNG,20,460);
            }            
        }
            
        zaehler+=2;
        zaehler%=displayWidth/2;
    }   
    
    public static void main(String[] passedArgs) 
    {
        String[] appletArgs = new String[] { "blusci.BLUSCI7SPRUNG" };
        if(passedArgs != null) 
        {
             PApplet.main(concat(appletArgs, passedArgs));
        } 
        else 
        {
            PApplet.main(appletArgs);
        }            
    }    
}
