package kiba.hilfsklassen;

import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

 /**
 *  <h4>Serverkommunikation.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Serverkommunikation
{
    public   String post(String[] name, String[] value, String in_url)
    {
System.out.println("***** Serverkommunikation.class: String post(String[] name, String[] value, String in_url) *****");

                if(name==null || value==null || name.length==0 || value.length==0 
                || name.length!=value.length || in_url==null || in_url.length()==0)
                {
                    System.out.println("Ungültige Übergabeparameter in class Internet, Methode String post(String[] name, String[] value, String url)");
                    return null;
                }

                for(int i=0;i<name.length;i++)
                {
                    if(name[i]==null || name[i].length()==0 || value[i]==null)
                    {
                       System.out.println("Unvollständige Übergabeparameter in class Internet, Methode String post(String[] name, String[] value, String url)");
                       return null;
                    }
                }

                try 
                {
                    String data = "";

                    for(int i=0;i<name.length;i++)
                    {
                        if(i>0)
                            data += "&";
                        data += URLEncoder.encode(name[i], "UTF-8") + "=" + URLEncoder.encode(value[i], "UTF-8");
                    }
                    URL url = new URL(in_url);
                    URLConnection conn = url.openConnection();
                    conn.setDoOutput(true);
                    OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
                    wr.write(data);
                    wr.flush();

                    //Antwort laden:
                    BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
                    StringBuffer gelesen = new StringBuffer();
                    String zeile="";
                    int anz=0;
                    boolean ok_sichern = true;
                    while ((zeile = rd.readLine()) != null) 
                    {
                        zeile = zeile.trim();
                        if(zeile!=null)
                        {
//System.out.println("Empfanene Zeile: "+zeile);
                            gelesen.append(zeile);    
                            gelesen.append("\n");
                        }
                    }

                    wr.close();
                    rd.close();                    
System.out.println("Daten zur Auswertung empfangen:\n"+gelesen.toString());
                   
                    String ausgabe = gelesen.toString();

                    if(  ausgabe!=null && ausgabe.length()>0 && !(ausgabe.length()>=5 && ( ausgabe.substring(0,5)).equals("ERROR") )  )
                    {
//Weiterverarbeitung (Darstellung der Punkte in Bildansicht)
System.out.println("Weiterverarbeitung der empfangenen Daten.");
                        return ausgabe;
                    }
                    else
                    {
                        System.out.println("Es wurde keine lesbare Daten empfangen.");
                        return null;
                    }
                }
                catch(Exception e)
                {
                    System.out.println(e);
                    return null;
                }
    }
    
    public static void main(String[] args)
    {
        Serverkommunikation server = new Serverkommunikation();

        String ping=server.post(new String[] {"test"},new String[] {"test"}, "http://localhost/kurzschrift/ping.php");
        System.out.println("http://localhost/kurzschrift/ping.php liefert:\""+ping+"\"");
    
    }
}


