package kiba.hilfsklassen;


 /**
 *  <h4>Sortierer.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
  public class Sortierer
  {

      /**Sortiert das übergebene Integer-Array in absteigender Folge*/
      public   int[] elementeumgekehrt(int[] vektor)
      {
          int[] erg = elemente(vektor);
          int[] hilf = new int[erg.length];
          
          for(int i=0;i<erg.length;i++)
              hilf[i] = erg[erg.length-1-i];
              
          return hilf;    
      }
  
      /**Sortiert das übergebene Integer-Array in aufsteigender Folge*/
      public   int[] elemente(int[] vektor)
      {
          int merker;
          int nummer=0;
          int[] ergebnis = {};
          
          if( vektor.length>0 )
          {     
          ergebnis = new int[vektor.length];     
          
          ergebnis[0] = vektor[0];
               
          for(int i=1;i<vektor.length;i++)
          {
              merker = vektor[i];
              
              nummer=0;
              
              while( ergebnis[nummer] < merker && nummer<i ) nummer++;
              
              for(int k=i-1; k>=nummer;k--) ergebnis[k+1]=ergebnis[k];
              ergebnis[nummer]=merker;   
                            
          }          
          }
          return ergebnis;
      }

      /**Liefert die Indices des übergebenen Integer-Array so, <br/>
      *  dass die zugehörigen Werte in aufsteigender Folge sortiert sind.
      */
      public   int[] nummern(int[] vektor)
      {
          //Liefert die Nummern der nach ansteigender Groesse geordneten
          //Elemente zurueck.
      
          int merker,merker2;
          int nummer=0;
          int[] ergebnis = {};
          int[] reihenfolge = {};
          
          if( vektor.length>0 )
          {     
          ergebnis    = new int[vektor.length];     
          reihenfolge = new int[vektor.length];     
          
          ergebnis[0] = vektor[0];
          for(int i=0;i<reihenfolge.length;i++) reihenfolge[i]=i;
               
          for(int i=1;i<vektor.length;i++)
          {
              merker  = vektor[i];
              merker2 = reihenfolge[i];
              
              nummer=0;
              
              while( ergebnis[nummer] < merker && nummer<i ) nummer++;
              
              for(int k=i-1; k>=nummer;k--) 
              {
                  ergebnis[k+1]=ergebnis[k];
                  reihenfolge[k+1]=reihenfolge[k];
              }    
              ergebnis[nummer]=merker;
              reihenfolge[nummer]=merker2;                               
          }          
          }
          return reihenfolge;
      }

      /**Liefert die Indices des übergebenen Long-Array so, <br/>
      *  dass die zugehörigen Werte in aufsteigender Folge sortiert sind.
      */
      public   int[] nummern(long[] vektor)
      {
          //Liefert die Nummern der nach ansteigender Groesse geordneten
          //Elemente zurueck.
      
          long merker;
          int merker2;
          int nummer=0;
          long[] ergebnis = {};
          int[] reihenfolge = {};
          
          if( vektor.length>0 )
          {     
          ergebnis    = new long[vektor.length];     
          reihenfolge = new int[vektor.length];     
          
          ergebnis[0] = vektor[0];
          for(int i=0;i<reihenfolge.length;i++) reihenfolge[i]=i;
               
          for(int i=1;i<vektor.length;i++)
          {
              merker  = vektor[i];
              merker2 = reihenfolge[i];
              
              nummer=0;
              
              while( ergebnis[nummer] < merker && nummer<i ) nummer++;
              
              for(int k=i-1; k>=nummer;k--) 
              {
                  ergebnis[k+1]=ergebnis[k];
                  reihenfolge[k+1]=reihenfolge[k];
              }    
              ergebnis[nummer]=merker;
              reihenfolge[nummer]=merker2;                               
          }          
          }
          return reihenfolge;
      }


      
      /**Liefert nur ungleiche Elemente sortiert in aufsteigender Reihenfolge.
      */
      public   int[] ungleiche(int[] vektor)
      {
          //1. sortieren
          int[] test = elemente(vektor);
          
          //2. zaehlen
          int anzahl = 0;
          int[] ergebnis = {};
          if( test.length > 1 )
          {
              anzahl = 1;
              for(int i=1;i<test.length;i++)
              {
                  if( test[i]!=test[i-1] ) anzahl++;
              }              
              ergebnis = new int[anzahl];
              ergebnis[0] = test[0];
              int xx=1;
              for(int i=1;i<test.length;i++)
              {
                  if( test[i]!=test[i-1] ) 
                  {
                     ergebnis[xx]=test[i];
                     xx++;
                  }   
              }              
          }
          else
          {
              if(test.length == 1) 
              {
                  anzahl=1;
                  ergebnis = new int[1];
                  ergebnis[0] = test[0];
              }    
          }        
          
          return ergebnis;
      }
  }

