package kiba.hilfsklassen;


 /**
 *  <h4>Unicode.java</h4>
 *
 *  Copyright (C) 2013 Guido Kramann<br/>
 *  kramann@fh-brandenburg.de<br/>
 *  http://www.kramann.info<br/>
 *  <br/>
 *  <p>  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  </p>
 *  <p>
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  </p>
 *  <p>
 *  You should have received a copy of the GNU General Public License
 *  along with this program (gpl.html).  If not, see http://www.gnu.org/licenses/.
 *  </p>
 */
public class Unicode
{
    /**
    Umwandlung in ASCII-Repräsentation in Form von 
    Zahlencodes der Unicode-Characterwerte.
    */
    public String toNumber(String text)
    {
        StringBuffer sb = new StringBuffer();
        int wert;
        for(char c : text.toCharArray())
        {
            wert = (int)c;
            if(wert<1000)
                 sb.append("0");
            if(wert<100)
                 sb.append("0");
            if(wert<10)
                 sb.append("0");
            sb.append(wert);
        }
        return sb.toString();
    }

    /**
    Wiederherstellung eines Textes aus seiner 
    Zahlencode aus Unicode-Repräsentation
    */
    public String toText(String number)
    {
        number = number.trim();
        if(number==null || number.length()==0)
           return null;

        StringBuffer sb = new StringBuffer();
        int wert;
        for(int i=0;i<number.length();i+=4)
        {
            if(i+3>number.length()-1)
            {
                System.out.println("ERROR in Unicode.toText(): Dokumentlänge ist ungültig");
                break;
            }
            wert = (int)(number.charAt(i))-48;
            wert*=10;            
            wert += (int)(number.charAt(i+1))-48;
            wert*=10;
            wert += (int)(number.charAt(i+2))-48;
            wert*=10;
            wert += (int)(number.charAt(i+3))-48;
            sb.append((char)wert+"");
        }
        return sb.toString();
    }

    public static void main(String[] args)
    {
        Unicode uc = new Unicode();
        String text = "Köln in schön\n und häßlich zugleich. §$%&";
        String umgewandelt = uc.toNumber(text);
        String wiederhergestellt = uc.toText(umgewandelt);
        System.out.println("\nAusgangstext:\n");
        System.out.println(text);
        System.out.println("\ncodiert:\n");
        System.out.println(umgewandelt);
        System.out.println("\nwiederhergestellt:\n");
        System.out.println(wiederhergestellt);
    }
}